<template>
  <!-- UpdateUser Form -->
  <form id="update-user-form" class="w-full">

    <!-- Error messages -->
    <t-alert v-if="form.globalError" variant="error" class="mb-8" show>
      <p class="text-error">{{ form.globalError }}</p>
    </t-alert>

    <!-- Firstname -->
    <Input
      v-model="firstnameValue"
      name="firstname"
      :variant="firstnameState ? 'primary' : 'error'"
      :state="firstnameState"
      :label="$h.capitalize($t('user.firstname'))"
      :placeholder="$h.capitalize($t('user.firstname'))"
      :error="getFieldErrorMessage('firstname')"
      fluid
    />

    <!-- Lastname -->
    <Input
      v-model="lastnameValue"
      name="lastname"
      :variant="lastnameState ? 'primary' : 'error'"
      :state="lastnameState"
      :label="$h.capitalize($t('user.lastname'))"
      :placeholder="$h.capitalize($t('user.lastname'))"
      :error="getFieldErrorMessage('lastname')"
      fluid
    />

    <!-- Email -->
    <Input
      v-model="emailValue"
      name="email"
      :variant="emailState ? 'primary' : 'error'"
      :state="emailState"
      :label="$h.capitalize($t('user.email'))"
      :placeholder="$h.capitalize($t('user.email'))"
      :error="getFieldErrorMessage('email')"
      fluid
      class="mb-4"
    />

    <!-- Confirm button -->
    <Button
      variant="primary"
      :disabled="!(isFormValid && hasChanged)"
      @click.native="handleOk"
      inline
      class="mr-4"
    >
      {{ $t('global.save') | capitalize }}
    </Button>

    <!-- Cancel button -->
    <Button
      variant="error"
      :disabled="!hasChanged"
      @click.native="handleCancel"
      inline
    >
      {{ $t('global.cancel') | capitalize }}
    </Button>

  </form>

</template>

<script>
// vuex helpers
import { mapState, mapActions } from 'vuex'
// BaseForm
import BaseForm from '@/components/commons/form/BaseForm'
// utils
import { validateEmail } from '#utils'

/**
 * UpdateUserForm component
 */
export default {
  name: 'UpdateUserForm',
  extends: BaseForm,
  // 'form' option (see src/components/commons/form/BaseForm)
  form: {
    fields: {
      /**
       * firstname
       */
      firstname: {
        // Default: generate 'firstnameValue' & 'firstnameChanged'
        default: function () {
          return this.$root.auth.user().firstname
        },
        // Generate: 'firstnameState'
        state: function () {
          return !this.isFieldInError('firstname') // No errors ?
            ? this.isFirstnameValid // Valid ?
            : false
        },
        // Generate: 'isFirstnameValid'
        isValid: function () {
          return this.firstnameValue.length > 0
        }
      },
      /**
       * lastname
       */
      lastname: {
        // Default: generate 'lastnameValue' & 'lastnameChanged'
        default: function () {
          return this.$root.auth.user().lastname
        },
        // Generate: 'lastnameState'
        state: function () {
          return !this.isFieldInError('lastname') // No errors ?
            ? this.isLastnameValid // Valid ?
            : false
        },
        // Generate: 'isLastnameValid'
        isValid: function () {
          return this.lastnameValue.length > 0
        }
      },
      /**
       * email
       */
      email: {
        // Default: generate 'emailValue' & 'emailChanged'
        default: function () {
          return this.$root.auth.user().email
        },
        // Generate: 'emailState'
        state: function () {
          return !this.isFieldInError('email') // No errors ?
            ? this.isEmailValid // Valid ?
            : false
        },
        // Generate: 'isEmailValid'
        isValid: function () {
          return validateEmail(this.emailValue)
        },
        failed: {
          ruleToErrorCode: {
            // Sort by most important rule error message to display
            'rule:Email': 'e0032',
            'rule:Unique': 'e0031'
          }
        }
      }
    }
  },
  computed: {
    // Map state from Auth module
    ...mapState('Auth', [
      'passwordForSecurity'
    ])
  },
  methods: {
    // Map actions from 'Auth' store module
    ...mapActions('Auth', [
      'loadCurrentUserData'
    ]),
    // Map actions from 'Users' store module
    ...mapActions('Users', [
      'updateUser'
    ]),
    /**
     * Handle click on 'confirm' submit button.
     * @param {Object} evt - The event payload
     * @returns {void}
     */
    handleOk (evt) {
      // Prevent click
      evt.preventDefault()
      // Reset errors before
      this.resetErrors()
      // Display PaswordGuardModal
      this.$store.commit('SET_SYSTEM_SHOW_PASSWORD_GUARD_MODAL', true)
      // Define 'one-time' callback on global event
      this.$root.once('PASSWORD_SECURITY_CONFIRMED', async () => {
        await this.saveData() // Save user data
        this.$store.commit('Auth/RESET_PASSWORD_FOR_SECURITY') // Reset passwordForSecurity
      })
    },
    /**
     * Handle click on 'cancel' button.
     * @param {Object} evt - The event payload
     * @returns {void}
     */
    handleCancel (evt) {
      // Prevent click
      evt.preventDefault()
      // Reset errors
      this.resetErrors()
      // Reset form
      this.resetForm()
    },
    /**
     * Handle click on data 'save' button.
     * @returns {void}
     */
    async saveData () {
      // Wait for update user function
      const updateUserResponse = await this.updateUser({
        userId: this.$root.auth.user().id,
        data: {
          firstname: this.firstnameValue,
          lastname: this.lastnameValue,
          email: this.emailValue,
          password: this.passwordForSecurity
        }
      })
      // If passed
      if (!(updateUserResponse instanceof Error)) {
        // Refresh current user data
        await this.loadCurrentUserData()
        // Reset form
        this.resetForm()
      // Else parse server error
      } else {
        this.setFormErrors(updateUserResponse) // Set form errors from response
      }
    }
  }
}
</script>
